import { Auth0ClientOptions, GetIdTokenClaimsOptions, GetTokenSilentlyOptions, GetTokenWithPopupOptions, IdToken, LogoutOptions, RedirectLoginOptions, User } from '@auth0/auth0-spa-js';
import { ComputedRef, Ref } from 'vue';
declare module '@vue/runtime-core' {
    interface ComponentCustomProperties {
        $auth: Record<string, any>;
    }
}
export interface AuthPlugin {
    isAuthenticated: ComputedRef<boolean>;
    loading: ComputedRef<boolean>;
    user: ComputedRef<User>;
    getIdTokenClaims: (o: GetIdTokenClaimsOptions) => Promise<IdToken>;
    getTokenSilently: (o: GetTokenSilentlyOptions) => Promise<any>;
    getTokenWithPopup: (o: GetTokenWithPopupOptions) => Promise<string>;
    handleRedirectCallback: () => Promise<void>;
    loginWithRedirect: (o: RedirectLoginOptions) => Promise<void>;
    loginWithPopup: () => Promise<void>;
    logout: (o: LogoutOptions) => void;
}
export interface AuthPluginOption {
    options: Auth0ClientOptions;
    callbackRedirect: any;
}
export declare const authPlugin: AuthPlugin;
export declare const createAuth0: (options: Auth0ClientOptions, callbackRedirect: any) => Promise<void>;
export declare const installAuth0: (config: AuthPluginOption) => Promise<{
    install: (app: any) => void;
}>;
export declare function provideAuth0(config: AuthPluginOption): Promise<void>;
export declare function useAuth0(): Ref<AuthPlugin>;
